require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_PERCPU_H)) {
    eval 'sub __LINUX_PERCPU_H () {1;}' unless defined(&__LINUX_PERCPU_H);
    require 'linux/spinlock.ph';
    require 'linux/slab.ph';
    require 'linux/smp.ph';
    require 'linux/string.ph';
    require 'asm/percpu.ph';
    unless(defined(&PERCPU_ENOUGH_ROOM)) {
	eval 'sub PERCPU_ENOUGH_ROOM () {32768;}' unless defined(&PERCPU_ENOUGH_ROOM);
    }
    eval 'sub get_cpu_var {
        local($var) = @_;
	    eval q((*({  &preempt_disable(); & &__get_cpu_var($var); })));
    }' unless defined(&get_cpu_var);
    eval 'sub put_cpu_var {
        local($var) = @_;
	    eval q( &preempt_enable());
    }' unless defined(&put_cpu_var);
    if(defined(&CONFIG_SMP)) {
	eval 'sub per_cpu_ptr {
	    local($ptr, $cpu) = @_;
    	    eval q(({ 1; ( &__typeof__($ptr)) ($__p->{ptrs[&(cpu)]}); }));
	}' unless defined(&per_cpu_ptr);
    } else {
	eval 'sub per_cpu_ptr {
	    local($ptr, $cpu) = @_;
    	    eval q(($ptr));
	}' unless defined(&per_cpu_ptr);
    }
    eval 'sub alloc_percpu {
        local($type) = @_;
	    eval q((( &__alloc_percpu($sizeof{$type},  &__alignof__($type)))));
    }' unless defined(&alloc_percpu);
    eval 'sub get_cpu_ptr {
        local($ptr) = @_;
	    eval q( &per_cpu_ptr($ptr,  &get_cpu()));
    }' unless defined(&get_cpu_ptr);
    eval 'sub put_cpu_ptr {
        local($ptr) = @_;
	    eval q( &put_cpu());
    }' unless defined(&put_cpu_ptr);
}
1;
